# coding: utf-8

"""
    Phrase TMS API

    Welcome to Phrase's TMS API documentation.    Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs.    If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new).    Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:  > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)  # noqa: E501

    The version of the OpenAPI document: Latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class ProjectTermBaseReference(BaseModel):
    """
    ProjectTermBaseReference
    """
    id: Optional[StrictStr] = None
    term_base: Optional[Dict[str, Any]] = Field(None, alias="termBase")
    name: Optional[StrictStr] = None
    write_mode: Optional[StrictBool] = Field(None, alias="writeMode")
    target_lang: Optional[StrictStr] = Field(None, alias="targetLang")
    read_mode: Optional[StrictBool] = Field(None, alias="readMode")
    workflow_step: Optional[Dict[str, Any]] = Field(None, alias="workflowStep")
    __properties = ["id", "termBase", "name", "writeMode", "targetLang", "readMode", "workflowStep"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProjectTermBaseReference:
        """Create an instance of ProjectTermBaseReference from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProjectTermBaseReference:
        """Create an instance of ProjectTermBaseReference from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProjectTermBaseReference.parse_obj(obj)

        _obj = ProjectTermBaseReference.parse_obj({
            "id": obj.get("id"),
            "term_base": obj.get("termBase"),
            "name": obj.get("name"),
            "write_mode": obj.get("writeMode"),
            "target_lang": obj.get("targetLang"),
            "read_mode": obj.get("readMode"),
            "workflow_step": obj.get("workflowStep")
        })
        return _obj

